# more additions to Tcl, for Lisp and lisp-like stuff
# Added by Jim Davis 2 Aug 94



proc remove-if {predicate l} {
    set l2 ""
    foreach i $l {if ![$predicate $i] "lappend l2 [list $i]"}
    return $l2}

proc oddp {n} {expr $n%2==1}
proc evenp {n} {expr $n%2==0}
proc zerop {n} {expr $n==0}

# I don't think you should use car and cdr in tcl code.
proc first {l} {lindex $l 0}
proc rest {l} {lrange $l 1 end}

proc second {l} {lindex $l 1}
proc third {l} {lindex $l 2}

# This should return an anonymous lambda function but those dont
# exist in tcl.  So instead it binds a gensym.
proc compose {f1 f2} {
    set name [gensym "C"]
    proc $name {i} "$f1 \[$f2 \$i\]"
    return $name}

set gensym_counter 0

proc gensym {c} {
    global gensym_counter
    return $c[incr gensym_counter]}

proc mapcar {f l} {
    set l2 {}
    foreach elt $l {lappend l2 [$f $elt]}
    return $l2}

proc lmax {l} {
   set x [lindex $l 0]
   foreach i $l {
      if {$i>$x} {set x $i}
   }
   return $x}

proc string-length {string} {string length $string}
