#
# displays a pop-up box with text, a credit line, a button to close
# and optionally a picture
#
# Jim Davis, Feb 22 1993

set help_font {-*-helvetica-medium-r-normal-*-14-*-*-*-*-*-*-*}
set help_color white

proc show-help-window {name text {credit ""} {bitmap {}}} {
    global help_font help_color
    catch {destroy .help}
    toplevel .help -background $help_color
    wm title .help $name
    message .help.text 	-background $help_color \
	 -font $help_font -width 400 -text $text
    message .help.credit -background $help_color \
	-font $help_font -width 1000 -text $credit
    if {$bitmap!={}} {button .help.picture -bitmap $bitmap}
#    button .help.close -text Okay -command {wm iconify .help}
    button .help.close -text Okay -command {destroy .help}
    pack append .help .help.text {top}
    frame .help.other -background $help_color
    pack append .help.other .help.credit {left} 
    if {$bitmap!={}} {pack append .help.other .help.picture {right}}
    pack append .help .help.other {top}
    pack append .help .help.close {bottom}
    }
